'************************************************************************
'*                                                                      *
'*   RapidQ Windows AVI player by Peter Scheutz Ver 0.1 10 Okt. 1999    *
'*   Freeware - use and improve                                         *
'*   Use "as is" no warrenty                                            *
'*                                                                      *
'*   Includes reusable AviFile Object                                   *
'*   OBS: NO encapsulation - therefore use methods only as shown below  *
'*                                                                      *
'*   Expect errors - this program has not been tested too much.         *
'*                                                                      *
'*   The SetWindowPos is used as a workaround. RQ seems to quit the     *
'*   current SUB when a Form is programmaticly resised.                 *
'*   This limitation may be removed in your/future versions and         *
'*   you can then revert to native RQ methods.                          *
'*                                                                      *
'*   Have Fun                                                           *
'*                                                                      *
'************************************************************************

$include "RapidQ.inc"

$APPTYPE GUI
$TYPECHECK ON

$RESOURCE PLAYBMP AS "PLAY.BMP"
$RESOURCE STOPBMP AS "STOP.BMP"

Declare Function mciSendString Lib "winmm.dll" Alias "mciSendStringA" (lpstrCommand As String, lpstrReturnString As String, uReturnLength As Long, hwndCallback As Long) As Long
Declare Function mciGetErrorString Lib "winmm.dll" Alias "mciGetErrorStringA" (dwError As Long, lpstrBuffer As String, uLength As Long) As Long
Declare Function SetWindowPos Lib "user32" Alias "SetWindowPos" (hwnd As Long, hWndInsertAfter As Long,x As Long,y As Long,cx As Long,cy As Long,wFlags As Long) As Long

Const HWND_TOPMOST = -1
Const SWP_SHOWWINDOW = &H40


Type AviFile extends Qobject
    mvarMediaOpen As Long
    CanvasHandle As Long
    currentFrame As Long
    mvarMediaName As String
    MediaLenght As Long
    MediaWidth As Long
    MediaHeight As Long
    mvarLastError As String


    Sub ParseMediaDimension(mediadim As String)
        ' this sub parses string containing "Xpos Ypos Xlen Ylen" seperated with spaces
        Dim sPos As Long
        Dim ePos As Long
        Dim x As Long
        Dim y As Long

        ePos=INSTR(,mediadim," ")
        x = Val(Mid$(mediadim, 1, ePos))

        sPos = ePos + 1
        ePos = InStr(sPos, mediadim, " ")
        y = Val(Mid$(mediadim, sPos, ePos - sPos))

        sPos = ePos + 1
        ePos = InStr(sPos, mediadim, " ")
        AviFile.MediaWidth = Val(Mid$(mediadim, sPos, ePos - sPos))

        sPos = ePos + 1
        AviFile.MediaHeight = Val(Mid$(mediadim, sPos, Len(mediadim) - sPos))

    End Sub

    Function GetMciDescription(McierrNr As Long) As String
        ' this function gets a txt description from a MCI error nr.
        Dim Retval As Long
        Dim RetString As String  'we don't use this - it ends up on the stack instead
        RetString = Space$(128)
        Retval = mciGetErrorString(McierrNr, RetString, 128)
        RetString = STACK.Str(1)
        If Retval = True Then
            AviFile.mvarLastError = RetString
        Else
            RetString = ""
        End If
        AviFile.GetMciDescription = RetString
    End Function


    Sub MakeMediaClose
        ' stops and closes loaded file - ignores errors call to make sure "MEDIA" alias is closed
        Dim Retval As Integer
        Dim RetString As String
        RetString = Space$(128)
        Retval = mciSendString("stop MEDIA", RetString, 128, 0)
        RetString = Space$(128)
        Retval = mciSendString("close MEDIA", RetString, 128, 0)
        AviFile.mvarMediaOpen = False
        'showmessage (str$(RetVal))
    End Sub
    Sub MakeMediaOpen
        ' opens file if not already open and toggle the MediaOpen flag
        If AviFile.mvarMediaOpen = False Then
            Dim Retval As Integer
            Dim RetString As String
            RetString = Space$(128)
            Retval = mciSendString("open " + AviFile.mvarMediaName + " alias MEDIA parent " + Str$(AviFile.CanvasHandle) + " style child", RetString, 128, 0)
            If Retval = 0 Then
                AviFile.mvarMediaOpen = True
            Else
                'showmessage(AviFile.GetMciDescription(retVal))
            End If

        End If

    End Sub
    Function GetPos As Long
        ' gets the current frame position of MEDIA (avi file)
        If AviFile.mvarMediaOpen = True Then
            Dim Retval As Integer
            Dim RetString As String
            Dim nowPos As String
            RetString = Space$(128)
            Retval = mciSendString("status MEDIA position", RetString, 128, 0)
            nowPos = STACK.Str(1)
            If Retval = 0 Then
                AviFile.currentFrame = Val(nowPos)
            End If
        End If
        AviFile.GetPos = AviFile.currentFrame
    End Function
    Function PlayMedia As Long
        ' plays video from current frame
        AviFile.MakeMediaOpen
        Dim Retval As Integer
        Dim RetString As String
        RetString = Space$(128)
        Retval = mciSendString("play MEDIA from " + Str$(AviFile.currentFrame), RetString, 128, 0)

        If Retval = 0 Then
            AviFile.PlayMedia = True
        Else
            'showmessage(AviFile.GetMciDescription(retVal))
            AviFile.PlayMedia = False
        End If

    End Function
    Sub StopMedia
        ' stops (pauses) video
        If AviFile.mvarMediaOpen = True Then
            AviFile.GetPos
            Dim Retval As Integer
            Dim RetString As String
            RetString = Space$(128)
            Retval = mciSendString("stop MEDIA", RetString, 128, 0)
        End If
    End Sub
    Sub SetMediaName(mName As String)
        ' use this to set the name of the video file, then call init
        AviFile.mvarMediaName = mName
        AviFile.currentFrame = 0
    End Sub

    Sub ShowStill
        ' show a certan frame number of the file - dont call this call "Setstill" instead
        AviFile.MakeMediaOpen
        Dim Retval As Integer
        Dim RetString As String
        RetString = Space$(128)
        Retval = mciSendString("play MEDIA from " + Str$(AviFile.currentFrame) + " to " + Str$(AviFile.currentFrame), RetString, 128, 0)

        If Retval <> 0 Then
            'showmessage(AviFile.GetMciDescription(retVal))
        End If
    End Sub
    Sub Setstill(frame As Long)
        ' call this to show a certain frame
        If AviFile.mvarMediaOpen = True Then
            If frame < 0 Then
                frame = 0
            End If
            If frame > AviFile.MediaLenght Then
                frame = AviFile.MediaLenght
            End If
            AviFile.currentFrame = frame
            AviFile.ShowStill
        End If
    End Sub
    Function Init As Long
        ' gets the size and number of frames of the avi file - returns False if error
        If AviFile.mvarMediaName = "" Then
            AviFile.Init = False
            Exit Function
        End If
        AviFile.Init = True
        AviFile.MakeMediaClose
        Dim Retval As Integer
        Dim RetString As String
        Dim errDescript As String
        RetString = Space$(128)
        Retval = mciSendString("open " + AviFile.mvarMediaName + " alias MEDIA", RetString, 128, 0)
        If Retval <> 0 Then
            AviFile.Init = False
            Exit Function
            'showmessage (AviFile.GetMciDescription(retval))
        End If
        RetString = Space$(128)
        Retval = mciSendString("status MEDIA length", RetString, 128, 0)
        RetString = STACK.Str(1)
        If Retval = 0 Then

            AviFile.MediaLenght = Val(RetString)
        Else
            AviFile.MediaLenght = -1 'invalid
            AviFile.Init = False
        End If

        RetString = Space$(128)
        Retval = mciSendString("where MEDIA source", RetString, 128, 0)
        RetString = STACK.Str(1)
        'showmessage(RetString)
        AviFile.ParseMediaDimension (RetString)

        RetString = Space$(128)
        Retval = mciSendString("close MEDIA", RetString, 128, 0)
        If Retval <> 0 Then
            AviFile.Init = False
            'showmessage (str$(RetVal)+"M " +AviFile.GetMciDescription(retval))
        End If

    End Function

    CONSTRUCTOR
    mvarMediaName = ""
    MediaLenght = -1
    mvarMediaOpen = False
    End CONSTRUCTOR

End Type

'*******************Test AviFile component*******************



Dim Video As AviFile
Dim font As Qfont
font.Name = "Arial"
font.Size = 12
font.AddStyles (fsBold)

Declare Sub PlayClick
Declare Sub StopClick
Declare Sub FormReSize
Declare Sub TrackBarChange
Declare Sub FormClose (Action AS INTEGER)
Declare Sub FormOnKeyDown (Key AS Word, Shift AS INTEGER)

CREATE Form AS QForm
    Caption = "Rapid Q Avi player"
    BorderStyle = bsToolWindow
    OnKeyDown = FormOnKeyDown
    OnResize = FormReSize
    OnClose = FormClose

    CREATE NavPanel AS QPanel
        Height = 32
        BevelOuter = bvNone

        CREATE TrackBar AS QTrackBar
            Left = 70
            Height = 18
            Top = 8
            TickStyle = tsNone
            TickMarks = tmBoth
            LineSize = 0
            OnChange = TrackBarChange
        END CREATE

        CREATE PlayBtn AS QCoolbtn
            BMPHandle = PLAYBMP
            Flat = True
            Left = 8: Top = 4: Height = 26: Width = 26
            Caption = ""
            OnClick = PlayClick
            font = font
            GroupIndex = 2
        END CREATE

        CREATE StopBtn AS QCoolbtn
            BMPHandle = STOPBMP
            Flat = True
            Left = 8 + 26: Top = 4: Height = 26: Width = 26
            Caption = ""
            OnClick = StopClick
            font = font
            GroupIndex = 2
        END CREATE
    END CREATE
END CREATE


' this timer is called when the avi is playing to show frame progress with trackbar
Dim PosTimer As Qtimer

Sub PostimerOnTimer
    Dim Retval As Short
    Retval = Video.GetPos
    TrackBar.Position = Retval
    DoEvents
    If Retval = Video.MediaLenght Then
        StopClick
        StopBtn.Down = True
        'PosTimer.Enabled=False
    End If
End Sub

PosTimer.Enabled = False
PosTimer.Interval = 1000
PosTimer.OnTimer = PostimerOnTimer



Dim MainMenu As QMainMenu
Dim File As QMenuItem
Dim Edit As QMenuItem
Dim Search As QMenuItem
DIM Open AS QMenuItem
Dim Break1 As QMenuItem
Dim ExitItem As QMenuItem

Dim OpenDialog As QOpenDialog
OpenDialog.Filter = "Video for Windows|*.AVI|"
OpenDialog.Caption= "Choose Avi file to open"

Sub FormClose(Action As Integer)
    'IF MessageDlg("Really close this form?", mtWarning, mbYes OR mbNo, 0) = mrNo THEN
    '  Action = caNone
    'else
' close video befor exiting
Video.MakeMediaClose
    'END IF
End Sub

Sub ExitClick
    Form.Close
End Sub
Sub FileClick
    ' stop video if playing, befor opening open dialog
    StopClick
    StopBtn.Down = True
End Sub
Sub OpenClick

    If OpenDialog.Execute Then
        Form.Cursor = crHourGlass
        Video.MakeMediaClose
        Video.SetMediaName OpenDialog.FileName
        Form.Caption = OpenDialog.FileName

        ' init AviFile object
        If Video.Init = False Then
            Video.SetMediaName ""
            Form.Caption = "Can't load: " + Form.Caption
            Form.Cursor = crDefault
            Exit Sub
        End If

        TrackBar.Max = Video.MediaLenght
        TrackBar.Position = 0

        ' I'd like to have all this stuff in a sub, but strange things happen
        ' It sizes the form to the size of the video
        ' and shows the first frame
        Dim BorderWidth As Long
        Dim BorderHeight As Long
        Dim NavHeight As Long
        Dim FormCenterX As Long
        Dim FormCenterY As Long
        Dim NewX As Long
        Dim NewY As Long
        FormCenterX = Form.Left + Form.Width / 2
        FormCenterY = Form.Top + Form.Height / 2

        NavHeight = NavPanel.Height
        BorderWidth = Form.Width - Form.ClientWidth
        BorderHeight = Form.Height - Form.ClientHeight
        NewX = FormCenterX - (Video.MediaWidth + BorderWidth) / 2
        NewY = FormCenterY - (Video.MediaHeight + NavHeight + BorderHeight) / 2
        If NewX < 0 Then
            NewX = 0
        End If
        If NewY < 0 Then
            NewY = 0
        End If
        Video.CanvasHandle = Form.Handle
        Video.ShowStill
        SetWindowPos Form.Handle, 0, NewX, NewY, Video.MediaWidth + BorderWidth, Video.MediaHeight + NavHeight + BorderHeight, SWP_SHOWWINDOW

    End If
End Sub

Open.Caption = "&Open"
Open.OnClick = OpenClick

Break1.Caption = "-"
ExitItem.Caption = "E&xit"
ExitItem.OnClick = ExitClick
File.Caption = "&File"
File.OnClick = FileClick


File.AddItems Open,Break1,ExitItem

MainMenu.Parent = Form
MainMenu.AddItems File


Sub PlayClick
    If Video.PlayMedia = True Then
        PosTimer.Enabled = True
    Else
        StopBtn.Down = True
    End If
End Sub

Sub StopClick
    PosTimer.Enabled = False
    Video.StopMedia
End Sub

Sub TrackBarChange
    Video.Setstill TrackBar.Position
End Sub

Sub FormReSize
    NavPanel.Top = Form.ClientHeight - NavPanel.Height
    NavPanel.Width = Form.ClientWidth
    TrackBar.Width = NavPanel.Width - TrackBar.Left - 10
End Sub

Form.center
Form.ShowModal

